/*

    File: log.c

    Copyright (C) 1998-2006 Christophe GRENIER <grenier@cgsecurity.org>
  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

 */
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
#include <stdio.h>
#ifdef HAVE_TIME_H
#include <time.h>
#endif
#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include "types.h"
#include "common.h"
#include "log.h"
#include "intrf.h"

FILE* log_open(const char*default_filename, const char *mode, const char *prog_name, int argc, char**argv)
{
  FILE *f_file;
  const char*filename=default_filename;
  do
  {
    f_file=fopen(filename,mode);
    if(f_file==NULL)
      filename=ask_log_location(filename);
  } while(f_file==NULL && filename!=NULL);
  if(f_file!=NULL)
  {
    int i;
    time_t my_time;
#ifdef HAVE_DUP2
    dup2(fileno(f_file),2);
#endif
    my_time=time(NULL);
    fprintf(f_file,"\n\n%s",ctime(&my_time));
    fprintf(f_file,"Command line: %s", prog_name);
    for(i=1;i<argc;i++)
      fprintf(f_file," %s", argv[i]);
    fprintf(f_file,"\n\n");
    fflush(f_file);
  }
  return f_file;
}

